'' =================================================================================================
''
''   File....... jm_grayenc_demo.spin
''   Purpose.... Greycode encoder test program
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2010 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 06 MAR 2010
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
' _xinfreq =  5_000_000
  _clkfreq = 80_000_000

  MS_001   = _clkfreq / 1_000


con

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control


obj

  term  : "fullduplexserial"                                    ' for terminal output
  level : "jm_grayenc2"                                         ' 2-bit, graycode encoder 


var


pub main | newlevel, oldlevel

  term.start(31, 30, %0000, 115_200)                            ' start terminal for test
  pause(5)
  term.tx(CLS)

  level.init(0, false, 0, 100, 50)                              ' non-detent encoder on p0/p1
' level.init(0, true, 0, 100, 50)                               ' detented encoder 

  pause(1)
  newlevel := level.read                                        ' read initial value
  
  repeat
    term.tx(HOME)                                               ' display it
    term.str(string("Encoder: "))
    term.dec(newlevel)
    term.tx(CLREOL)

    oldlevel := newlevel                                        ' setup to detect change
    repeat
      newlevel := level.read                                    ' poll encoder                                   
    until (newlevel <> oldlevel)                                '  until it changes  


pub pause(ms) | t

  t := cnt
  repeat ms
    waitcnt(t += MS_001)

 